import com.urbancode.anthill3.AHPTool;
import org.apache.commons.httpclient.*
import org.apache.commons.httpclient.methods.*;
import org.apache.commons.httpclient.auth.AuthScope;

final def ahpTool = new AHPTool()
final def props = ahpTool.getStepProperties()
def out = System.out;

def timeout = props['timeout']
out.println("Timeout : " + timeout)
def user = props['user'];
out.println("User : ${user}");
def url = props['url'];
out.println("URL : ${url}");
def verifyString = props['verifyString'];
out.println("Verify String : ${verifyString}");
def base_url = new URL(url).getHost();
out.println("Host : ${base_url}");
def port = new URL(url).getPort();
out.println("Port : ${port}");
def password = (props['password']?props['password']:(props['passScript']?props['passScript']:null));

HttpClient client = new HttpClient()
if(password) {
    client.getParams().setAuthenticationPreemptive(true)
    Credentials defaultcreds = new UsernamePasswordCredentials(user, password)
    client.getState().setCredentials(new AuthScope(base_url, port), defaultcreds)
}
if(timeout) {
	client.setConnectionTimeout(Long.valueOf(timeout));
}

HttpMethod method = null
def response=null
def result=0;
try {
    method = new GetMethod(url)
    result = client.executeMethod(method)
    response = method.getResponseBodyAsString()
}
finally {
    if(method != null) {
        method.releaseConnection();
    }
}
if(result <200 || result > 299) {
    out.println("Error result code recieved : ${result}");
    out.println(response);
    System.exit(1);
}
if(!response) {
    out.println("No response received from url : ${url}");
    System.exit(1);
}
if(response =~ verifyString) {
    out.println("Response matches the verify String");
    System.exit(0);
}
out.println("Response did not match the verify string");
out.println(response);
System.exit(1);